/*@lineinfo:filename=HelloWorld*//*@lineinfo:user-code*//*@lineinfo:1^1*//*
   The program HelloWorld.sqlj illustrates how to connect to a
   database, and display the words "Hello World" along with
   the current date.
*/

// import required packages
import java.sql.Date;
import java.sql.SQLException;
import oracle.sqlj.runtime.Oracle;

public class HelloWorld {

  public static void main(String [] args) {

    java.sql.Date current_date;

    try {

      // connect to the database
      Oracle.connect(
        "jdbc:oracle:thin:@localhost:1521:orcl",
        "scott",
        "tiger"
      );

      // get the current date from the database
      /*@lineinfo:generated-code*//*@lineinfo:28^7*/

//  ************************************************************
//  #sql { SELECT sysdate  FROM dual  };
//  ************************************************************

{
  sqlj.runtime.profile.RTResultSet __sJT_rtRs;
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, HelloWorld_SJProfileKeys.getKey(0), 0);
    try 
    {
      sqlj.runtime.profile.RTResultSet __sJT_result = __sJT_execCtx.executeQuery();
      __sJT_rtRs = __sJT_result;
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
  try 
  {
    sqlj.runtime.ref.ResultSetIterImpl.checkColumns(__sJT_rtRs, 1);
    if (!__sJT_rtRs.next())
    {
      sqlj.runtime.error.RuntimeRefErrors.raise_NO_ROW_SELECT_INTO();
    }
    current_date = __sJT_rtRs.getDate(1);
    if (__sJT_rtRs.next())
    {
      sqlj.runtime.error.RuntimeRefErrors.raise_MULTI_ROW_SELECT_INTO();
    }
  }
  finally 
  {
    __sJT_rtRs.close();
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:28^58*/

      // display message
      System.out.println("Hello World! The current date is " +
        current_date);

    } catch ( SQLException e ) {
      System.err.println("SQLException " + e);
    } finally {
      try {

        // disconnect from the database
        Oracle.close();

      } catch ( SQLException e ) {
        System.err.println("SQLException " + e);
      }
    }

  } // end of main()

}/*@lineinfo:generated-code*/class HelloWorld_SJProfileKeys 
{
  private static HelloWorld_SJProfileKeys inst = null;
  public static java.lang.Object getKey(int keyNum) 
    throws java.sql.SQLException 
  {
    if (inst == null)
    {
      inst = new HelloWorld_SJProfileKeys();
    }
    return inst.keys[keyNum];
  }
  private final sqlj.runtime.profile.Loader loader = sqlj.runtime.RuntimeContext.getRuntime().getLoaderForClass(getClass());
  private java.lang.Object[] keys;
  private HelloWorld_SJProfileKeys() 
    throws java.sql.SQLException 
  {
    keys = new java.lang.Object[1];
    keys[0] = sqlj.runtime.ref.DefaultContext.getProfileKey(loader, "HelloWorld_SJProfile0");
  }
}
