import java.sql.SQLException;
import oracle.jdbc.driver.OracleConnection;
import oracle.jdbc.driver.OracleTypes;
import oracle.sql.CustomDatum;
import oracle.sql.CustomDatumFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class TAddress4 implements CustomDatum, CustomDatumFactory
{
  public static final String _SQL_NAME = "OBJECT_USER.T_ADDRESS4";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

  static final TAddress4 _TAddress4Factory = new TAddress4();
  public static CustomDatumFactory getFactory()
  {
    return _TAddress4Factory;
  }

  /* constructors */
  public TAddress4()
  {
    this((String[])null);
  }

  public TAddress4(String[] a)
  {
    _array = new MutableArray(a, 12, null);
  }

  /* CustomDatum interface */
  public Datum toDatum(OracleConnection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* CustomDatumFactory interface */
  public CustomDatum create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    TAddress4 a = new TAddress4();
    a._array = new MutableArray((ARRAY) d, 12, null);
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public String[] getArray() throws SQLException
  {
    return (String[]) _array.getObjectArray();
  }

  public void setArray(String[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public String[] getArray(long index, int count) throws SQLException
  {
    return (String[]) _array.getObjectArray(index, count);
  }

  public void setArray(String[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public String getElement(long index) throws SQLException
  {
    return (String) _array.getObjectElement(index);
  }

  public void setElement(String a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
