import java.sql.SQLException;
import oracle.jdbc.driver.OracleConnection;
import oracle.jdbc.driver.OracleTypes;
import oracle.sql.CustomDatum;
import oracle.sql.CustomDatumFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class TCustomerRef implements CustomDatum, CustomDatumFactory
{
  public static final String _SQL_BASETYPE = "OBJECT_USER.T_CUSTOMER";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

  static final TCustomerRef _TCustomerRefFactory = new TCustomerRef();
  public static CustomDatumFactory getFactory()
  {
    return _TCustomerRefFactory;
  }

  /* constructor */
  public TCustomerRef()
  {
  }

  /* CustomDatum interface */
  public Datum toDatum(OracleConnection c) throws SQLException
  {
    return _ref;
  }

  /* CustomDatumFactory interface */
  public CustomDatum create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    TCustomerRef r = new TCustomerRef();
    r._ref = (REF) d;
    return r;
  }
  public TCustomer getValue() throws SQLException
  {
     return (TCustomer) TCustomer.getFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(TCustomer c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getConnection()));
  }
}
